diff --git a/meta/recipes-core/musl/musl.inc b/meta/recipes-core/musl/musl.inc
index ba9b1a046c..319709b3cb 100644
--- a/meta/recipes-core/musl/musl.inc
+++ b/meta/recipes-core/musl/musl.inc
@@ -9,7 +9,7 @@ standards-conformance and safety."
 HOMEPAGE = "http://www.musl-libc.org/"
 LICENSE = "MIT"
 SECTION = "libs"
-LIC_FILES_CHKSUM = "file://COPYRIGHT;md5=2b9032093c4765e49ae85ddeba29afff"
+LIC_FILES_CHKSUM = "file://COPYRIGHT;md5=8a4bb28f771c817fe57d3a7c4240e3aa"
 
 PATH_prepend = "${STAGING_BINDIR_TOOLCHAIN}.${STAGINGCC}:"
 
diff --git a/meta/recipes-core/musl/musl/0001-Define-MAX_HANDLE_SZ.patch b/meta/recipes-core/musl/musl/0001-Define-MAX_HANDLE_SZ.patch
deleted file mode 100644
index b1217723a3..0000000000
--- a/meta/recipes-core/musl/musl/0001-Define-MAX_HANDLE_SZ.patch
+++ /dev/null
@@ -1,29 +0,0 @@
-From e2e723cfe96ce6ed6558ed7e8fbb44b2283297da Mon Sep 17 00:00:00 2001
-From: Khem Raj <raj.khem@gmail.com>
-Date: Thu, 13 Sep 2018 06:57:28 -0700
-Subject: [PATCH] Define MAX_HANDLE_SZ
-
-MAX_HANDLE_SZ is described in name_to_handle_at() to contain maximum
-expected size for a file handle
-
-Upstream-Status: Submitted [https://www.openwall.com/lists/musl/2018/09/13/16]
-Signed-off-by: Khem Raj <raj.khem@gmail.com>
----
- include/fcntl.h | 1 +
- 1 file changed, 1 insertion(+)
-
-diff --git a/include/fcntl.h b/include/fcntl.h
-index 5c3defcb..6a8b6d49 100644
---- a/include/fcntl.h
-+++ b/include/fcntl.h
-@@ -166,6 +166,7 @@ struct f_owner_ex {
- };
- #define FALLOC_FL_KEEP_SIZE 1
- #define FALLOC_FL_PUNCH_HOLE 2
-+#define MAX_HANDLE_SZ 128
- #define SYNC_FILE_RANGE_WAIT_BEFORE 1
- #define SYNC_FILE_RANGE_WRITE 2
- #define SYNC_FILE_RANGE_WAIT_AFTER 4
--- 
-2.19.0
-
diff --git a/meta/recipes-core/musl/musl/0001-wireup-linux-name_to_handle_at-and-name_to_handle_at.patch b/meta/recipes-core/musl/musl/0001-wireup-linux-name_to_handle_at-and-name_to_handle_at.patch
deleted file mode 100644
index 4738e1efd8..0000000000
--- a/meta/recipes-core/musl/musl/0001-wireup-linux-name_to_handle_at-and-name_to_handle_at.patch
+++ /dev/null
@@ -1,76 +0,0 @@
-From ef3ef607693a9513d5ab94a1de67dd2f1f97d8ad Mon Sep 17 00:00:00 2001
-From: Khem Raj <raj.khem@gmail.com>
-Date: Wed, 12 Sep 2018 16:08:40 -0700
-Subject: [PATCH] wireup linux/name_to_handle_at and name_to_handle_at syscalls
-
-Upstream-Status: Submitted [https://www.openwall.com/lists/musl/2018/09/13/4]
-Signed-off-by: Khem Raj <raj.khem@gmail.com>
----
- include/fcntl.h               |  7 +++++++
- src/linux/name_to_handle_at.c | 11 +++++++++++
- src/linux/open_by_handle_at.c | 10 ++++++++++
- 3 files changed, 28 insertions(+)
- create mode 100644 src/linux/name_to_handle_at.c
- create mode 100644 src/linux/open_by_handle_at.c
-
-diff --git a/include/fcntl.h b/include/fcntl.h
-index 6d8edcd1..5c3defcb 100644
---- a/include/fcntl.h
-+++ b/include/fcntl.h
-@@ -155,6 +155,11 @@ int lockf(int, int, off_t);
- #define F_OWNER_PID 1
- #define F_OWNER_PGRP 2
- #define F_OWNER_GID 2
-+struct file_handle {
-+	unsigned int handle_bytes;
-+	int handle_type;
-+	unsigned char f_handle[];
-+};
- struct f_owner_ex {
- 	int type;
- 	pid_t pid;
-@@ -170,6 +175,8 @@ struct f_owner_ex {
- #define SPLICE_F_GIFT 8
- int fallocate(int, int, off_t, off_t);
- #define fallocate64 fallocate
-+int name_to_handle_at(int, const char *, struct file_handle *, int *, int);
-+int open_by_handle_at(int, struct file_handle *, int);
- ssize_t readahead(int, off_t, size_t);
- int sync_file_range(int, off_t, off_t, unsigned);
- ssize_t vmsplice(int, const struct iovec *, size_t, unsigned);
-diff --git a/src/linux/name_to_handle_at.c b/src/linux/name_to_handle_at.c
-new file mode 100644
-index 00000000..bb6f8007
---- /dev/null
-+++ b/src/linux/name_to_handle_at.c
-@@ -0,0 +1,11 @@
-+#define _GNU_SOURCE
-+#include <fcntl.h>
-+#include "syscall.h"
-+
-+int name_to_handle_at(int dirfd, const char *pathname,
-+			struct file_handle *handle,
-+			int *mount_id, int flags)
-+{
-+	return syscall(SYS_name_to_handle_at, dirfd,
-+		pathname, handle, mount_id, flags);
-+}
-diff --git a/src/linux/open_by_handle_at.c b/src/linux/open_by_handle_at.c
-new file mode 100644
-index 00000000..9bc93f14
---- /dev/null
-+++ b/src/linux/open_by_handle_at.c
-@@ -0,0 +1,10 @@
-+#define _GNU_SOURCE
-+#include <fcntl.h>
-+#include "syscall.h"
-+
-+int open_by_handle_at(int mount_fd, struct file_handle *handle,
-+                             int flags)
-+{
-+	return syscall(SYS_open_by_handle_at, mount_fd,
-+		handle, flags);
-+}
--- 
-2.19.0
-
diff --git a/meta/recipes-core/musl/musl_git.bb b/meta/recipes-core/musl/musl_git.bb
index f0556533b5..0d8f8eb2a4 100644
--- a/meta/recipes-core/musl/musl_git.bb
+++ b/meta/recipes-core/musl/musl_git.bb
@@ -4,7 +4,7 @@
 require musl.inc
 inherit linuxloader
 
-SRCREV = "0fa1e638e87cf257e9f96b4019b2076afd674a19"
+SRCREV = "c50985d5c8e316c5c464f352e79eeebfed1121a9"
 
 PV = "1.1.20+git${SRCPV}"
 
@@ -12,8 +12,6 @@ PV = "1.1.20+git${SRCPV}"
 
 SRC_URI = "git://git.musl-libc.org/musl \
            file://0001-Make-dynamic-linker-a-relative-symlink-to-libc.patch \
-           file://0001-wireup-linux-name_to_handle_at-and-name_to_handle_at.patch \
-           file://0001-Define-MAX_HANDLE_SZ.patch \
           "
 
 S = "${WORKDIR}/git"